//*****************************************************************************************************
//  1. t@C
//		BaseDraw.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot`拤ʊNX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2007.08.09 S.Aizawa VK쐬
//*****************************************************************************************************

#include "StdAfx.h"
#include "BaseDraw.h"
#include <math.h>

//*****************************************************************************************************
//  1. ֐
//		CBaseDraw::GetLinearScaleStep
//----------------------------------------------------------------------------------------------------
//  2. @\
//		jAXP[̖ڐ̃Xebv擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fRange		[I] XP[̃Wiőlƍŏl̍j
//		int			nPixel		[I] XP[̃sNZ
//		int			*pStep		[O] Xebv̕
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		double		PڐԂ̃Xebvl
//*****************************************************************************************************
double CBaseDraw::GetLinearScaleStep(double fRange, int nPixel, int *pStep)
{
	double t1, t2;
	int nStep;

	if (fRange <= 0)
		return 1;

	t1 = fRange / nPixel;
	double fStep = pow(10.0, floor(log10(t1)));
	t2 = t1 / fStep;
	if (t2 < 2) {
		fStep *= 0.5;
		nStep = 2;
	} else if (t2 < 5)
		nStep = 2;
	else
		nStep = 5;

	if (pStep != NULL)
		*pStep = nStep;

	return fStep;
}

//*****************************************************************************************************
//  1. ֐
//		CBaseDraw::GetLogScaleStep
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ΐXP[̖ڐ̃Xebv擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fValue		[I] ݂̖ڐ̒l
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		double		PڐԂ̃Xebvl
//*****************************************************************************************************
double CBaseDraw::GetLogScaleStep(double fValue)
{
	return pow(10, floor(log10(fValue) + 1e-3));
}

//*****************************************************************************************************
//  1. ֐
//		CBaseDraw::GetScaleStartValue
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ŏ̖ڐ̒l擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double		fMinValue		[I] XP[̍ŏl
//		double		fStep			[I] ڐ̃Xebv
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		double		ŏ̖ڐ̒l
//*****************************************************************************************************
double CBaseDraw::GetScaleStartValue(double fMinValue, double fStep)
{
	return floor(fMinValue / fStep + 1e-3) * fStep;
}
